#include <cstdio>
#include <cstdlib>
#include <windows.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	LPSTR lpParameter = lpCmdLine;
	bool bQuoted = false;
	int nError = 0;

	// Hilfe anzeigen:
	if (*lpCmdLine == '\0') {
		MessageBox(NULL, "Aufruf mit:\nAUTORUN <Dateiname> [<Parameterliste>]", "A u t o R u n", MB_OK | MB_ICONSTOP);
		return EXIT_FAILURE;
	}

	// Kommandozeile mittels \0 in Dateiname und Parameterliste trennen:
	while ((*lpParameter != '\0') && ((*lpParameter != ' ') || bQuoted)) {
		if (*lpParameter == '\"')
			bQuoted = !bQuoted;
		lpParameter++;
	}
	if (*lpParameter != '\0') {
		*lpParameter = '\0';
		lpParameter++;
	}
	else
		lpParameter = NULL;

	// ShellExecute() aufrufen und ggf. Fehlermeldung anzeigen:
	if ((nError = (int)ShellExecute(NULL, NULL, lpCmdLine, lpParameter, NULL, SW_SHOWNORMAL)) <= 32) {
		char *szMsg = "\"%s\" konnte nicht gestartet werden!";
		char *szBuf = new char[strlen(szMsg) + strlen(lpCmdLine) + 1];
		sprintf(szBuf, szMsg, lpCmdLine);
		MessageBox(NULL, szBuf, "A u t o R u n", MB_OK | MB_ICONSTOP);
		delete[] szBuf;
		return nError;
	}

	return EXIT_SUCCESS;
}
